#!/usr/bin/env python
#
# Grib content manager
# When the grib_checker is no longer needed this makes manage GRIB files
# a simple task
# Shorter version of grib content within grib_checker
#
# Barcerlona Supercomputing Center - Centro Nacional de Supercomputacion
#        Earth Sciences Department - Computational Earth Sciences
#     
#     Authors: Joan Sala Calero (joan.sala@bsc.es)
#             -
#

import os

def list_files_folder(path):
    list_files = []
    if os.path.exists(path):
        if os.path.isfile(path) and path.endswith("grib") or path.endswith("nc") or path.endswith("grb"):
            list_files.append(path) 
        if os.path.isdir(path) or os.path.isfile(path):
            for root, dirs, files in os.walk(path):                
                for f in files:
                    if f.endswith("grib") or f.endswith("nc") or f.endswith("grb"):
                        list_files.append(os.path.join(root,f))
        
            return sorted(list_files)

        else:
            raise Exception('\n\tGiven path is not a valid path\n')

def dir_or_file(path):
    if os.path.isfile(path):
        print("INFO: Checking file")
        print(path)
        # do the file checking
        return [path]

    elif os.path.isdir(path):        
        # list all files in the folder
        list_files = list_files_folder(path)        
        print("INFO: Path {}".format(path))
        print("INFO: Found {} files to check".format(len(list_files)))
        
        if len(list_files):
            print("INFO: [1]: {}".format(os.path.basename(list_files[0])))
            print("INFO: [N]: {}".format(os.path.basename(list_files[-1])))
        else:
            raise Exception('No files found for analysis')

        return list_files            
       